from typing import Generic, TypeVar

from rainbowadn.nullability import *
from .chaincollectioninterface import *

__all__ = ('ChainCollectionFactory',)

BlockType = TypeVar('BlockType')
HeaderType = TypeVar('HeaderType')


class ChainCollectionFactory(Generic[BlockType, HeaderType]):
    def empty(self) -> ChainCollectionInterface[BlockType, HeaderType]:
        raise NotImplementedError

    def from_reference(
            self,
            reference: NullableReference[BlockType]
    ) -> ChainCollectionInterface[BlockType, HeaderType]:
        raise NotImplementedError

    def loose(self) -> 'ChainCollectionFactory[BlockType, HeaderType]':
        return self
