from typing import Generic, TypeVar

from rainbowadn.chain import *
from rainbowadn.core import *
from .wrisbtindex import *
from .wrisbtprotocol import *

__all__ = ('WrisbtChainProtocol',)

TargetType = TypeVar('TargetType')


class WrisbtChainProtocol(
    BlockChainProtocol[
        TargetType,
        WrisbtIndex
    ],
    Generic[TargetType]
):
    def __init__(
            self,
            total_factory: RainbowFactory[TargetType],
            keymin: int
    ):
        assert isinstance(total_factory, RainbowFactory)
        assert isinstance(keymin, int)
        assert keymin > 0
        self.keymin = keymin
        super().__init__(
            WrisbtProtocol(keymin),
            total_factory,
            WrisbtIndexFactory(keymin)
        )
        self.total_factory = total_factory
